Presage Class Reference

Presage, the intelligent predictive text entry platform. More...

`#include <presage.h>`

Collaboration diagram for Presage:

## Public Member Functions

| Presage (PresageCallback *callback) throw (PresageException)
| Presage (PresageCallback *callback, const std::string config) throw (PresageException)
| ~Presage ()
std::vector< std::string > | predict () throw (PresageException)
| Obtain a prediction. More...
std::multimap< double, std::string > | predict (std::vector< std::string > filter) throw (PresageException)
| Obtain a prediction that matches the supplied token filter. More...
PresageCallback * | callback (PresageCallback *callback) throw (PresageException)
| Callback getter/setter. More...
std::string | completion (std::string str) throw (PresageException)
| Request presage to return the completion string for the given predicted token. More...
std::string | context () const throw (PresageException)
| Returns the text entered so far. More...
bool | context_change () const throw (PresageException)
| Returns true if a context change occured. More...
std::string | prefix () const throw (PresageException)
| Returns the current prefix. More...
std::string | config (const std::string variable) const throw (PresageException)
| Gets the value of specified configuration variable. More...
void | config (const std::string variable, const std::string value) const throw (PresageException)
| Sets the value of specified configuration variable. More...
void | save_config () const throw (PresageException)
| Save current configuration to file. More...

## Private Attributes

ProfileManager * | profileManager
Configuration * | configuration
PredictorRegistry * | predictorRegistry
ContextTracker * | contextTracker
PredictorActivator * | predictorActivator
Selector * | selector

## Detailed Description

Presage, the intelligent predictive text entry platform.

Definition at line 116 of file presage.h.

## Constructor & Destructor Documentation

Presage::Presage | ( | PresageCallback * | callback | ) |
throw | ( | PresageException
| ) |  |

Creates and initializes presage.

Parameters

  callback | is a user-supplied implementation of PresageCallback interface

Presage does not take ownership of the callback object.

Definition at line 33 of file presage.cpp.

Presage::Presage | ( | PresageCallback * | callback,
|  | const std::string | config
| ) |  |
throw | ( | PresageException
| ) |  |

Creates and initializes presage with supplied configuration.

Parameters

  callback | is a user-supplied implementation of PresageCallback interface
  config | path to configuration file

Presage does not take ownership of the callback object.

Definition at line 44 of file presage.cpp.

Presage::~Presage | ( |  | ) |

Destroys presage.

Definition at line 55 of file presage.cpp.

References contextTracker, predictorActivator, predictorRegistry, profileManager, and selector.

## Member Function Documentation

PresageCallback * Presage::callback | ( | PresageCallback * | callback | ) |
throw | ( | PresageException
| ) |  |

Callback getter/setter.

Parameters

  callback | to be used by presage (pass a null pointer to obtain callback to current callback without modifying it)

Returns
  pointer to previously used callback

Definition at line 139 of file presage.cpp.

std::string Presage::completion | ( | std::string | str | ) |
throw | ( | PresageException
| ) |  |

Request presage to return the completion string for the given predicted token.

Requests presage to return the completion string. The completion string is defined as the string which, when appended to the current prefix, forms the token passed as the str argument.

Parameters

  str | successful prediction, for which a completion string is requested

Returns
  completion string

Definition at line 145 of file presage.cpp.

References PRESAGE_TOKEN_PREFIX_MISMATCH_ERROR.

Referenced by main(), and presage_completion().

Here is the caller graph for this function:

std::string Presage::config | ( | const std::string | variable | ) | const
throw | ( | PresageException
| ) |  |

Gets the value of specified configuration variable.

Programmatically get the value currently assigned to the specified configuration

Parameters

  variable |

Returns
  value assigned to configuration variable.

Definition at line 211 of file presage.cpp.

Referenced by main(), presage_config(), and presage_config_set().

Here is the caller graph for this function:

void Presage::config | ( | const std::string | variable,
|  | const std::string | value
| ) |  | const
throw | ( | PresageException
| ) |  |

Sets the value of specified configuration variable.

Programmatically set the specified configuration

Parameters

  variable | to
  value | . This will override the setting read from the configuration file in use.

Definition at line 217 of file presage.cpp.

std::string Presage::context | ( |  | ) | const
throw | ( | PresageException
| ) |  |

Returns the text entered so far.

Returns
  context, text entered so far.

Definition at line 193 of file presage.cpp.

References contextTracker, and ContextTracker::getPastStream().

Referenced by main(), and presage_context().

Here is the call graph for this function:

Here is the caller graph for this function:

bool Presage::context_change | ( |  | ) | const
throw | ( | PresageException
| ) |  |

Returns true if a context change occured.

Returns
  true if a context change occured after the last update or predict calls, or false otherwise.

Definition at line 199 of file presage.cpp.

References ContextTracker::contextChange(), and contextTracker.

Referenced by main(), and presage_context_change().

Here is the call graph for this function:

Here is the caller graph for this function:

std::vector< std::string > Presage::predict | ( |  | ) |
throw | ( | PresageException
| ) |  |

Obtain a prediction.

This method requests that presage generates a prediction based on the current context.

Returns
  prediction (vector of strings) based on the current context.

Definition at line 64 of file presage.cpp.

References contextTracker, Selector::get_suggestions(), PredictorActivator::predict(), predictorActivator, Selector::select(), selector, Prediction::size(), and ContextTracker::update().

Referenced by main(), presage_predict(), and Simulator::simulate().

Here is the call graph for this function:

Here is the caller graph for this function:

std::multimap< double, std::string > Presage::predict | ( | std::vector< std::string > | filter | ) |
throw | ( | PresageException
| ) |  |

Obtain a prediction that matches the supplied token filter.

Parameters

  filter | a vector of strings to use to filter the prediction for desired tokens. I.e. If the current prefix is "gr" and the filter is ["ea", "an"], then only words starting with "grea" or "gran" such as "great" or "grand" will be returned in the prediction.

Returns
  prediction containing only tokens that begin with one of the filter tokens.

Definition at line 90 of file presage.cpp.

References Suggestion::getProbability(), Prediction::getSuggestion(), and Prediction::size().

Here is the call graph for this function:

std::string Presage::prefix | ( |  | ) | const
throw | ( | PresageException
| ) |  |

Returns the current prefix.

Returns
  prefix

Definition at line 205 of file presage.cpp.

References contextTracker, and ContextTracker::getPrefix().

Referenced by Simulator::find(), and presage_prefix().

Here is the call graph for this function:

Here is the caller graph for this function:

void Presage::save_config | ( |  | ) | const
throw | ( | PresageException
| ) |  |

Save current configuration to file.

Call this method to persist current presage configuration to file. The configuration data will be saved to the currently active XML profile.

Definition at line 223 of file presage.cpp.

References profileManager, and ProfileManager::save_profile().

Referenced by presage_save_config().

Here is the call graph for this function:

Here is the caller graph for this function:

## Member Data Documentation

Configuration* Presage::configuration

private

Definition at line 242 of file presage.h.

ContextTracker* Presage::contextTracker

private

Definition at line 244 of file presage.h.

Referenced by context(), context_change(), predict(), prefix(), and ~Presage().

PredictorActivator* Presage::predictorActivator

private

Definition at line 245 of file presage.h.

Referenced by predict(), and ~Presage().

PredictorRegistry* Presage::predictorRegistry

private

Definition at line 243 of file presage.h.

Referenced by ~Presage().

ProfileManager* Presage::profileManager

private

Definition at line 241 of file presage.h.

Referenced by save_config(), and ~Presage().

Selector* Presage::selector

private

Definition at line 246 of file presage.h.

Referenced by predict(), and ~Presage().

The documentation for this class was generated from the following files:

- /build/buildd/presage-0.8.8/src/lib/presage.h
- /build/buildd/presage-0.8.8/src/lib/presage.cpp